# Program 4: ConsumeInteger.py
# Class that consumes integers

import threading
import random
import time

class ConsumeInteger( threading.Thread ):
   """Thread to consume integers"""

   def __init__( self, threadName, sharedObject ):
      """Initialize thread, set shared object"""

      threading.Thread.__init__( self, name = threadName )
      self.sharedObject = sharedObject

   def run( self ):
      """Consume 10 values at random time intervals"""

      sum = 0             # total sum of consumed values

      # consume 10 values
      for i in range( 10 ):
         time.sleep( random.randrange( 4 ) )
         sum += self.sharedObject.getSharedNumber()

      print "%s retrieved values totaling: %d" % \
         ( self.getName(), sum )
      print "Terminating", self.getName()
