# Program 3: ProduceInteger.py
# Class that produces integers

import threading
import random
import time

class ProduceInteger( threading.Thread ):
   """Thread to produce integers"""

   def __init__( self, threadName, sharedObject ):
      """Initialize thread, set shared object"""

      threading.Thread.__init__( self, name = threadName )
      self.sharedObject = sharedObject

   def run( self ):
      """Produce integers in range 1-10 at random intervals"""

      for i in range( 1, 11 ):
         time.sleep( random.randrange( 4 ) )
         self.sharedObject.setSharedNumber( i )

      print self.getName(), "finished producing values"
      print "Terminating", self.getName()
